testpearsonkernel <- function(X,Y)
{
 T <- length(X)
 gammaT <- log(T)

 sigX <- sqrt(mean(X^2)-(mean(X))^2) 
 sigY <- sqrt(mean(Y^2)-(mean(Y))^2) 
 sigXY <- mean(X*Y)-mean(X)*mean(Y)
 
 D111 <- mean(X^4) - (mean(X^2))^2
 D112 <- mean(X^2*Y^2) - mean(X^2) * mean(Y^2) 
 D113 <- mean(X^3) - mean(X^2) * mean(X) 
 D114 <- mean(X^2*Y) - mean(X^2) * mean(Y) 
 D115 <- mean(X^2*X*Y) - mean(X^2) * mean(X*Y) 
 D122 <- mean(Y^4) - (mean(Y^2))^2 
 D123 <- mean(Y^2*X) - mean(Y^2) * mean(X) 
 D124 <- mean(Y^3) - mean(Y^2) * mean(Y) 
 D125 <- mean(X*Y^3) - mean(Y^2) * mean(X*Y) 
 D133 <- mean(X^2) - (mean(X))^2
 D134 <- mean(X*Y) - mean(X) * mean(Y) 
 D135 <- mean(X^2*Y) - mean(X) * mean(X*Y) 
 D144 <- mean(Y^2) - (mean(Y))^2 
 D145 <- mean(X*Y^2) - mean(Y) * mean(X*Y) 
 D155 <- mean(X^2*Y^2) - (mean(X*Y))^2 


  D111m <- D112m <- D113m <- D114m <- D115m <- D122m <- D123m <- D124m <- D125m <- D133m <- D134m <- D135m <- D144m <- D145m <- D155m <- 0

##   for (i in 1:floor(T^(1/4)))
     for (i in 1:floor(gammaT))
    {     
      
##      Ki <- 1 - abs(i/floor(T^(1/4)))
      Ki <- 1 - abs(i/floor(gammaT))
      D111m <- D111m + Ki * 2 * ((T-i)/T*mean((X^2)[1:(T-i)]*(X^2)[(1+i):T]) - mean(X^2)*mean(X^2))
      D112m <- D112m + Ki * ((T-i)/T*mean((X^2)[1:(T-i)]*(Y^2)[(1+i):T]) + (T-i)/T*mean((Y^2)[1:(T-i)]*(X^2)[(1+i):T]) - 2* mean(X^2)*mean(Y^2))
      D113m <- D113m + Ki * ((T-i)/T*mean((X^2)[1:(T-i)]*X[(1+i):T]) + (T-i)/T*mean(X[1:(T-i)]*(X^2)[(1+i):T]) - 2* mean(X^2)*mean(X))
      D114m <- D114m + Ki * ((T-i)/T*mean((X^2)[1:(T-i)]*Y[(1+i):T]) + (T-i)/T*mean(Y[1:(T-i)]*(X^2)[(1+i):T]) - 2* mean(X^2)*mean(Y))
      D115m <- D115m + Ki * ((T-i)/T*mean((X^2)[1:(T-i)]*(X*Y)[(1+i):T]) + (T-i)/T*mean((X*Y)[1:(T-i)]*(X^2)[(1+i):T]) - 2* mean(X^2)*mean(X*Y))
      D122m <- D122m + Ki * 2 * ((T-i)/T*mean((Y^2)[1:(T-i)]*(Y^2)[(1+i):T]) - mean(Y^2)*mean(Y^2))
      D123m <- D123m + Ki * ((T-i)/T*mean((Y^2)[1:(T-i)]*X[(1+i):T]) + (T-i)/T*mean(X[1:(T-i)]*(Y^2)[(1+i):T]) - 2* mean(Y^2)*mean(X))
      D124m <- D124m + Ki * ((T-i)/T*mean((Y^2)[1:(T-i)]*Y[(1+i):T]) + (T-i)/T*mean(Y[1:(T-i)]*(Y^2)[(1+i):T]) - 2* mean(Y^2)*mean(Y))
      D125m <- D125m + Ki * ((T-i)/T*mean((Y^2)[1:(T-i)]*(X*Y)[(1+i):T]) + (T-i)/T*mean((X*Y)[1:(T-i)]*(Y^2)[(1+i):T]) - 2* mean(Y^2)*mean(X*Y))
      D133m <- D133m + Ki * 2 * ((T-i)/T*mean(X[1:(T-i)]*X[(1+i):T]) - mean(X)*mean(X))
      D134m <- D134m + Ki * ((T-i)/T*mean(Y[1:(T-i)]*X[(1+i):T]) + (T-i)/T*mean(X[1:(T-i)]*Y[(1+i):T]) - 2* mean(X)*mean(Y))
      D135m <- D135m + Ki * ((T-i)/T*mean(X[1:(T-i)]*(X*Y)[(1+i):T]) + (T-i)/T*mean((X*Y)[1:(T-i)]*X[(1+i):T]) - 2* mean(X)*mean(X*Y))
      D144m <- D144m + Ki * 2 * ((T-i)/T*mean(Y[1:(T-i)]*Y[(1+i):T]) - mean(Y)*mean(Y))
      D145m <- D145m + Ki * ((T-i)/T*mean(Y[1:(T-i)]*(X*Y)[(1+i):T]) + (T-i)/T*mean((X*Y)[1:(T-i)]*Y[(1+i):T]) - 2* mean(Y)*mean(X*Y))
      D155m <- D155m + Ki * 2 * ((T-i)/T*mean((X*Y)[1:(T-i)]*(X*Y)[(1+i):T]) - mean(X*Y)*mean(X*Y))

     

      }
 
D111 <- D111 + D111m
D112 <- D112 + D112m
D113 <- D113 + D113m
D114 <- D114 + D114m
D115 <- D115 + D115m
D122 <- D122 + D122m
D123 <- D123 + D123m
D124 <- D124 + D124m
D125 <- D125 + D125m
D133 <- D133 + D133m
D134 <- D134 + D134m
D135 <- D135 + D135m
D144 <- D144 + D144m
D145 <- D145 + D145m
D155 <- D155 + D155m


D1 <- matrix(c(D111,D112,D113,D114,D115,D112,D122,D123,D124,D125,D113,D123,D133,D134,D135,D114,D124,D134,D144,D145,D115,D125,D135,D145,D155),ncol=5,byrow=T)

D2 <- matrix(c(1,0,-2*mean(X),0,0,0,1,0,-2*mean(Y),0,0,0,-mean(Y),-mean(X),1),ncol=5,byrow=T)

 D31 <- -0.5*(sigXY/sigY)*sigX^(-3)
 D32 <- -0.5*(sigXY/sigX)*sigY^(-3)
 D33 <- 1/(sigX*sigY)

D3 <- matrix(c(D31,D32,D33),ncol=3)

c <- (D3 %*% D2 %*% D1 %*% t(D2) %*% t(D3))^(-1/2)
kormittel <- cor(X,Y)
vektor <- rep(0,T-1)
vektorneu <- rep(0,T-1)

for(i in 2:T)
{
vektor[i-1] <- cor(X[1:i],Y[1:i])
vektorneu[i-1] <- i/sqrt(T) * c * abs(vektor[i-1]-kormittel)
}
ergebnis <- max(vektorneu,na.rm=T)
return(ergebnis)
}

testpearsonbootstrap <- function(X1,X2,b=199)

{

n <- length(X1)

l <- floor(n^(1/4))

p <- 2

cor12 <- cor(X1,X2)

correlations <- rep(0,n)

for(i in 2:n)
{

correlations[i] <- cor(X1[1:i],X2[1:i]) - cor12

correlations[i] <- i/sqrt(n) * correlations[i]

}

## Block bootstrap

bootstrapvalues <- matrix(0,ncol=p*(p-1)/2,nrow=b)
for(j in 1:b)
{

a <- sample(1:(n-l+1),n/l,replace=T)

X1b <- as.vector(sapply(a,function(x) X1[x:(x+l-1)]))
X2b <- as.vector(sapply(a,function(x) X2[x:(x+l-1)]))

bootstrapvalues[j,1] <- cor(X1b,X2b)

bootstrapvalues[j,] <- sqrt(n) * bootstrapvalues[j,]

}

D <- var(bootstrapvalues)

Dm12 <- 1/sqrt(D) 

correlations <-  abs(Dm12 * correlations)

teststatistic <- max(correlations,na.rm=T)

return(teststatistic)

}

# 4-variater Test:


testpearsonbootstrap4 <- function(X1,X2,X3,X4,b=199)

{

n <- length(X1)

l <- floor(n^(1/4))

p <- 4

cor12 <- cor(X1,X2)
cor13 <- cor(X1,X3)
cor14 <- cor(X1,X4)
cor23 <- cor(X2,X3)
cor24 <- cor(X2,X4)
cor34 <- cor(X3,X4)

correlations <- matrix(0,ncol=p*(p-1)/2,nrow=n)

for(i in 2:n)
{

correlations[i,1] <- cor(X1[1:i],X2[1:i]) - cor12
correlations[i,2] <- cor(X1[1:i],X3[1:i]) - cor13
correlations[i,3] <- cor(X1[1:i],X4[1:i]) - cor14
correlations[i,4] <- cor(X2[1:i],X3[1:i]) - cor23
correlations[i,5] <- cor(X2[1:i],X4[1:i]) - cor24
correlations[i,6] <- cor(X3[1:i],X4[1:i]) - cor34

correlations[i,] <- i/sqrt(n) * correlations[i,]

}

## Block bootstrap

bootstrapvalues <- matrix(0,ncol=p*(p-1)/2,nrow=b)
for(j in 1:b)
{

##X1b <- sample(X1,n,replace=T)
##X2b <- sample(X2,n,replace=T)
##X3b <- sample(X3,n,replace=T)
##X4b <- sample(X4,n,replace=T)

a <- sample(1:(n-l+1),n/l,replace=T)

X1b <- as.vector(sapply(a,function(x) X1[x:(x+l-1)]))
X2b <- as.vector(sapply(a,function(x) X2[x:(x+l-1)]))
X3b <- as.vector(sapply(a,function(x) X3[x:(x+l-1)]))
X4b <- as.vector(sapply(a,function(x) X4[x:(x+l-1)]))

##a <- sample(1:(n/l),n/l,replace=T)

##X1b <- as.vector(sapply(a,function(x) X1[((x-1)*l+1):((x-1)*l+1+l)]))
##X2b <- as.vector(sapply(a,function(x) X2[((x-1)*l+1):((x-1)*l+1+l)]))
##X3b <- as.vector(sapply(a,function(x) X3[((x-1)*l+1):((x-1)*l+1+l)]))
##X4b <- as.vector(sapply(a,function(x) X4[((x-1)*l+1):((x-1)*l+1+l)]))

bootstrapvalues[j,1] <- cor(X1b,X2b)
bootstrapvalues[j,2] <- cor(X1b,X3b)
bootstrapvalues[j,3] <- cor(X1b,X4b)
bootstrapvalues[j,4] <- cor(X2b,X3b)
bootstrapvalues[j,5] <- cor(X2b,X4b)
bootstrapvalues[j,6] <- cor(X3b,X4b)

bootstrapvalues[j,] <- sqrt(n) * bootstrapvalues[j,]

}

D <- cov(bootstrapvalues)

##tsboot(ts(data),cov,99,l=1,sim="fixed")

Dm12 <- eigen(D)$vectors %*% diag(1/sqrt(eigen(D)$values)) %*% t(eigen(D)$vectors)

correlations <-  apply(correlations,1,function(x) Dm12 %*% x)

correlations <- abs(correlations)

correlations <- apply(correlations,2,sum)

teststatistic <- max(correlations)

return(teststatistic)

}
